Bug 531218 - Ridiculously slow compilation
Ridiculously slow compilation
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: gcc (Show other bugs)
12
All Linux
low Severity medium
: ---
: ---
Assigned To: Jakub Jelinek
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-10-27 07:07 EDT by Susi Lehtola
Modified: 2010-02-11 11:49 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-02-11 11:49:32 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Preprocessed source (43.78 KB, application/octet-stream)
2010-01-13 16:55 EST, Susi Lehtola
no flags Details

  None (edit)
Description Susi Lehtola 2009-10-27 07:07:59 EDT
There seems to be some kind of a bug in gcc-4.4.2-4.fc12 that makes compilation ridiculously slow. The srpm

http://theory.physics.helsinki.fi/~jzlehtol/rpms/psi-3.4.0-3.fc12.src.rpm

has been building in koji
 http://koji.fedoraproject.org/koji/taskinfo?taskID=1768528
for 21 hours now. On EPEL 5 (gcc-4.1.2-46.el5) the same srpm builds with the same options within a half hour or so.

The problems seem to come out in the compilation of the libint library, that is machine generated.
Comment 1 Bug Zapper 2009-11-16 09:24:25 EST
This bug appears to have been reported against 'rawhide' during the Fedora 12 development cycle.
Changing version to '12'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 2 Orcan Ogetbil 2009-12-11 21:49:49 EST
I have the same problem with bug 539222 and the review request bug 537363 .

Both compile fine on F-11 but take forever on F-12.

For the latter one I figured that the -O2 flag is what makes the compilations stall. I take -O2 out and the compilation time drops from days to seconds.

Will this be fixed soon?
Comment 3 Jakub Jelinek 2010-01-13 04:03:21 EST
Please try http://kojipkgs.fedoraproject.org/packages/gcc/4.4.2/24.fc12/
Comment 4 Susi Lehtola 2010-01-13 14:09:34 EST
Has been compiling for almost 10 hours, so there doesn't seem to be any improvement.
Comment 5 Jakub Jelinek 2010-01-13 14:15:37 EST
Can you please provide preprocessed source for the file on which it takes so long,
and all gcc options passed to it?
FYI, 4.4.2-24.fc12 isn't in dist-12-build nor dist-f13-build, so if you are just trying to build it in koji, it will use an older gcc.
Comment 6 Susi Lehtola 2010-01-13 16:55:07 EST
Created attachment 383564 [details]
Preprocessed source

Preprocessed source file.
Comment 7 Susi Lehtola 2010-01-13 16:58:11 EST
Attachment in comment #6 compiles on my desktop in 40 us with plain "g++ -c", in 19 s with "g++ -O2 -c", but with the standard flags "g++ -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector --param=ssp-buffer-size=4 -m64 -mtune=generic" it takes a *really* long time.

(In reply to comment #5)
> FYI, 4.4.2-24.fc12 isn't in dist-12-build nor dist-f13-build, so if you are
> just trying to build it in koji, it will use an older gcc.    

Yes, that's why I used mock with a local repo providing the new gcc packages that were picked up for the build.
Comment 8 Jakub Jelinek 2010-01-14 04:24:26 EST
I guess I'll resurrect the gcc44-max-vartrack-size.patch, but this time with a 50000000 default instead of 5000000.  That way it shouldn't trigger on reasonably sized testcases and will only trigger on these monsters.
Comment 9 Jakub Jelinek 2010-02-11 11:49:32 EST
gcc-4.4.2-4.fc12 with the above mentioned default vartrack size limit has been released as errata.

Note You need to log in before you can comment on or make changes to this bug.